﻿using System.Data;

using Dapper;

namespace TestProject
{
    /// <summary>
    /// 역할 타입 핸들러
    /// </summary>
    public class RoleTypeHandler : SqlMapper.TypeHandler<Role>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 파싱하기 - Parse(value)

        /// <summary>
        /// 파싱하기
        /// </summary>
        /// <param name="value">값</param>
        /// <returns>역할</returns>
        public override Role Parse(object value)
        {
            return UserModel.GetRole(value.ToString());
        }

        #endregion
        #region 값 설정하기 - SetValue(parameter, value)

        /// <summary>
        /// 값 설정하기
        /// </summary>
        /// <param name="parameter">매개 변수</param>
        /// <param name="value">값</param>
        public override void SetValue(IDbDataParameter parameter, Role value)
        {
            parameter.Value = value.ToString();
        }

        #endregion
    }
}