﻿using System;

namespace TestProject
{
    /// <summary>
    /// 사용자 모델
    /// </summary>
    public class UserModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ID - ID

        /// <summary>
        /// ID
        /// </summary>
        public string ID { get; set; }

        #endregion
        #region 성명 - NAME

        /// <summary>
        /// 성명
        /// </summary>
        public string NAME { get; set; }

        #endregion
        #region 역할 - ROLE

        /// <summary>
        /// 역할
        /// </summary>
        public Role ROLE { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 역할 구하기 - GetRole(value)

        /// <summary>
        /// 역할 구하기
        /// </summary>
        /// <param name="value">값</param>
        /// <returns>역할</returns>
        public static Role GetRole(string value)
        {
            if(string.IsNullOrWhiteSpace(value))
            {
                return Role.None;
            }

            string[] valueItemArray = value.Split(',');

            Role role = Role.None;

            int valueItemArrayLength = valueItemArray.Length;

            for(int i = 0; i < valueItemArrayLength; i++)
            {
                string valueItem = valueItemArray[i];

                if(i == 0)
                {
                    role = (Role)Enum.Parse(typeof(Role), valueItem);
                }
                else
                {
                    role |= (Role)Enum.Parse(typeof(Role), valueItem);
                }
            }

            return role;
        }

        #endregion
    }
}